/*
 * Copyright (C) 2025 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.vorgang.vorgang.redirect;

import org.springframework.beans.factory.annotation.Lookup;
import org.springframework.stereotype.Service;

import de.ozgcloud.vorgang.vorgang.VorgangService;
import lombok.RequiredArgsConstructor;

@Service
@RequiredArgsConstructor
class ForwardingRemoteService {

	private final VorgangService vorgangService;
	private final ForwardingRequestMapper forwardingRequestMapper;

	public void forward(ForwardingRequest request) {
		var eingang = vorgangService.getById(request.getVorgangId()).getEingangs().getFirst();
		var grpcRouteForwarding = forwardingRequestMapper.toGrpcRouteForwarding(request, eingang);
		getEingangForwarder().forward(grpcRouteForwarding, eingang.getAttachments(), eingang.getRepresentations());
	}

	@Lookup
	EingangForwarder getEingangForwarder() {
		return null; // provided by Spring
	}
}
